# ntv.tcl v1.0 by domsen <domsen@domsen.org> (c)2oo3
#
# comments? bugs? ideas? requests? money? beer? 
# plz mail me or visit my homepage @ www.domsen.org
# also check out www.uid-zero.de
#
# das  tcl  liest  die www.n-tv.de  news  aus und gibt sie  wieder,  gleich mit
# dem link zum eigentlichen artikel. per trigger lassen sich auch die letzten X
# news von hand auslesen.
#
# v1.3 - erste public version
#
# ntvtrigger - der trigger auf den der bot reagiert (public und message)
# ntvlimit - maximum der news die auf befehl geposted werden
# ntvnewspost  - 1 fr newsposting, 0 fr keines
# ntvchans  - die  chans in  denen das tcl aktiv  ist, "" fr alle
# ntvnewspostlimit - maximum der news die geposted werden
# isntvhub  - legt fest ob der bot newshub ist oder nicht
# ntvleafs  - die nicks der leafbots auf denen das leaf tcl luft
#
####### config ######################

set ntvtrigger ".ntv"
set ntvchans ""
set ntvlimit "5"
set ntvnewspostlimit "3"
set ntvnewspost "1"
set isntvhub "0"
set ntvleafs ""

####### ende der config #############

bind msg - $ntvtrigger msg_ntv
bind pub - $ntvtrigger pub_ntv
bind time - "?0 * * * *" ntvcheck

proc html { text } {
regsub -all "&uuml;" $text "" text
regsub -all "&ouml;" $text "" text
regsub -all "&auml;" $text "" text
regsub -all "&Uuml;" $text "" text
regsub -all "&Ouml;" $text "" text
regsub -all "&Auml;" $text "" text
regsub -all "&szlig;" $text "" text
regsub -all "&quot;" $text "\"" text
return $text
}

proc sendntvnews { arg } {
global ntvleafs
foreach bot [bots] {
if {([lsearch -exact [string tolower $ntvleafs] [string tolower $bot]] != -1)} {
putbot $bot "ntv: $arg"
}}}

proc shrink { calc number string start bl} { return [expr [string first "$string" $bl $start] $calc $number] }

proc ntvnews { target limit } {
if {[catch {set sock [socket www.n-tv.de  80] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET /suche.html?sorting=live&query=*&stich=oder&hq=&zeitraum=2d HTTP/1.1"
puts $sock "User-Agent: Microsoft owns, Netscape suxx"
puts $sock "Host: www.n-tv.de "
puts $sock "Connection: close"
puts $sock ""
flush $sock
set counter 0
while {[eof $sock] != 1} {
set bl [gets $sock]

if {[string first "<td><a href=\"/" $bl] != -1} {
set link "www.n-tv.de[string range $bl [shrink + 6 "href=\"" 0 $bl] [shrink - 1 "\" " 0 $bl]]"
set newsline [string range $bl [shrink + 6 "Norm\">" 0 $bl] [shrink - 1 "</a>" 0 $bl]]

putserv "privmsg $target :[incr counter] [html $newsline] <$link>"
}
if {$counter == $limit} {close $sock; return 0}
}}}


proc ntvcheck {nick uhost hand chan arg} {
global ntvchans ntvnewspost isntvhub ntvnewspostlimit
set counter 0
if {$ntvnewspost == 1 } {
putlog "ntv: suche nach neuer newsline"
set ntvlastnews "none"
if {[file exists ntv.hdl]} {
set temp [open "ntv.hdl" r]
set ntvlastnews [gets $temp]
if {$ntvlastnews == ""} { set ntvlastnews "none" }
close $temp
}
set temp [open "ntv.hdl" w+]
if {[catch {set sock [socket www.n-tv.de  80] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET /suche.html?sorting=live&query=*&stich=oder&hq=&zeitraum=2d HTTP/1.1"
puts $sock "User-Agent: Microsoft owns, Netscape suxx"
puts $sock "Host: www.n-tv.de "
puts $sock "Connection: close"
puts $sock ""
flush $sock
while {[eof $sock] != 1} {
set bl [gets $sock]
if {[string first "<td><a href=\"/" $bl] != -1} {
set link "www.n-tv.de[string range $bl [shrink + 6 "href=\"" 0 $bl] [shrink - 1 "\" " 0 $bl]]"
set newsline [string range $bl [shrink + 6 "Norm\">" 0 $bl] [shrink - 1 "</a>" 0 $bl]]
puts $temp "[html $newsline] <$link>"
}}}
close $sock ; close $temp
if {$ntvlastnews == "none" } { putlog "ntv: headlinefile created" ; return 0 }
set temp [open "ntv.hdl" r]
while { [eof $temp] != 1 } {
set ntvneunews [html [gets $temp]]
if {($ntvlastnews == $ntvneunews) || ($counter == $ntvnewspostlimit)} { close $temp;return 0 }
if { $isntvhub == "1" } { sendntvnews $ntvneunews }
incr counter
foreach chan [channels] {
if {$ntvchans == "" } { putserv "privmsg $chan :(neue ntv newsline) $ntvneunews" }
if {$ntvchans != "" } {
if {([lsearch -exact [string tolower $ntvchans] [string tolower $chan]] != -1) || ($ntvchans == "")} {putserv "privmsg $chan :(neue ntv newsline) $ntvneunews"}
}
}}}}


proc msg_ntv { nick uhost hand arg } { global ntvlimit ; ntvnews $nick $ntvlimit }
proc pub_ntv { nick uhost hand chan arg } { global ntvchans ntvlimit ; if {([lsearch -exact [string tolower $ntvchans] [string tolower $chan]] != -1) || ($ntvchans == "")} { ntvnews $nick $ntvlimit }}


putlog "*** ntv.tcl v1.0 by domsen <domsen@domsen.org> succesfully loaded"

#[EOF]
